import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.beans.*;
import java.util.*;
import com.javawisdom.util.print.*;

public class JtableTest  extends JApplet{
	
	JPanel mainPanel;
	
	JTabbedPane tabPane;
	JTableAppPanel jtablePanel;
	JvPrinter jvprinter;
	
	
	ButtonsAppPanel buttonsAppPanel;
	
		public JtableTest()
	{
	super();
		try
		{
		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
  		SwingUtilities.updateComponentTreeUI(this);
		}
		catch (Exception e)
		{System.out.println (e.toString());
		}
		
    	mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout(5, 5));

		tabPane = new JTabbedPane();
		jvprinter = new JvPrinter();
		
		jtablePanel = new JTableAppPanel(this);
		tabPane.addTab("Jtable", jtablePanel);
		buttonsAppPanel = new ButtonsAppPanel(this);

		mainPanel.add(tabPane, BorderLayout.CENTER);
		mainPanel.add(buttonsAppPanel, BorderLayout.SOUTH);
	
		getContentPane().add(mainPanel, BorderLayout.CENTER);
	}


			public static void main(String args[])
	{

		JtableTest testApp = new JtableTest();
		testApp.setBounds(6,6,550,650);
		testApp.show();
	}
	
	
	}
// Defines a Jpanel which contains a Jtable to print
class JTableAppPanel extends JPanel
{
	JtableTest jtableTest;
    // Creates a jtable
	JTable jtable;
    // Creates a Jpanel
	JPanel tablePanel;

	public JTableAppPanel(JtableTest jtableTest)
	{
		this.jtableTest = jtableTest;
		setLayout(new BorderLayout(4, 4));

		DefaultTableModel model = new DefaultTableModel();
		
		jtable = createTable();

		tablePanel = new JPanel();
		tablePanel.setLayout(new BorderLayout(5, 5));
		tablePanel.add(new JScrollPane(jtable), BorderLayout.CENTER);

		add(tablePanel, BorderLayout.CENTER);
	}

	public JTable createTable()
	{
		final String[] names =
		{
	 	  "UserName",
	 	  "Password",
	 	  "City",
     	};

		final Object[][] data =
		{  {"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" },
		{"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" },
		{"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" },
		{"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" },
		{"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" },
		{"Scott", "guessagain","HongKong" },
		{"jim", "guessagain","LonDon" },
		{"joe", "guessagain","Roma" },
		{"john", "guessagain","Sandy" }
	};

		TableModel dataModel = new AbstractTableModel()
		{
	   	public int getColumnCount() { return names.length; }
	    public int getRowCount() { return data.length;}
		public Object getValueAt(int row, int col) {return data[row][col];}
	    public String getColumnName(int column) {return names[column];}
	    public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
	    public boolean isCellEditable(int row, int col) {return col != 5;}
	    public void setValueAt(Object aValue, int row, int column) { data[row][column] = aValue; }
		};

		JTable tableView = new JTable(dataModel);
		tableView.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		for(int i = 0; i < names.length; i++)
		{
			tableView.getColumn(names[i]).setPreferredWidth(150);
		}



		JComboBox comboBox = new JComboBox();
	 	comboBox.addItem("HongKong");
	 	comboBox.addItem("Roma");
	 	comboBox.addItem("LonDon");
	 	comboBox.addItem("Sandy");
	;


		TableColumn cityColumn = tableView.getColumn("City");
		cityColumn.setCellEditor(new DefaultCellEditor(comboBox));



		tableView.setRowHeight(25);

		return tableView;
	}

	public Component getComponent()
	{
		return jtable;
	}

	public void reset()
	{
		DefaultTableModel model = (DefaultTableModel)jtable.getModel();

	}
}
 
class ButtonsAppPanel extends JPanel implements ActionListener
{
	JtableTest jtabletest;

	JButton pageSetupButton;
	JButton previewButton;
	JButton printButton;

	public ButtonsAppPanel(JtableTest jtabletest)
	{
		this.jtabletest = jtabletest;
		setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));

		pageSetupButton = new JButton("Page Setup");
		pageSetupButton.addActionListener(this);

		previewButton = new JButton("Preview");
		previewButton.addActionListener(this);

		printButton = new JButton("Print");
		printButton.addActionListener(this);

		add(pageSetupButton);
		add(previewButton);
		add(printButton);
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == pageSetupButton)
		{
			jtabletest.jvprinter.pageSetup(new JFrame());
		}
		else if(e.getSource() == previewButton)
		{
		
			jtabletest.jvprinter.setJTable((JTable)jtabletest.jtablePanel.getComponent());
		
			jtabletest.jvprinter.preview(new JFrame());
		}
		else if(e.getSource() == printButton)
		{
        	jtabletest.jvprinter.setJTable((JTable)jtabletest.jtablePanel.getComponent());
			jtabletest.jvprinter.print();
		}
	}
}